part of masamune;

FocusNode useAutoFocusNode([bool autoFocus = true]) {
  final focusNode = useFocusNode();
  useEffect(
    () {
      if (autoFocus) {
        focusNode.requestFocus();
      }
      return () {};
    },
    [focusNode],
  );
  return focusNode;
}

extension WidgetRefFocusNodeExtensions on WidgetRef {
  FocusNode useFocusNode(String key, [bool autoFocus = true]) {
    final container = get<FocusNode?>(key, null);
    if (container == null) {
      final focusNode = FocusNode();
      if (autoFocus) {
        focusNode.requestFocus();
      }
      return this[key] = focusNode;
    }
    return container;
  }
}
