part of masamune;

extension WidgetRefEffectExtensions on WidgetRef {
  void effect({
    VoidCallback? onInitOrUpdate,
    VoidCallback? onDispose,
    List<Object> keys = const [],
  }) {
    const key = r"_$effect";
    final container = get<_EffectContainer?>(key, null);
    if (container == null || container.keys != keys) {
      onInitOrUpdate?.call();
      this[key] = _EffectContainer(
        onDispose: onDispose,
        keys: keys,
      );
    }
  }
}

@immutable
class _EffectContainer extends DisposableContainer {
  const _EffectContainer({
    required this.onDispose,
    required this.keys,
  });
  final VoidCallback? onDispose;
  final List<Object> keys;

  @override
  void dispose() {
    onDispose?.call();
    super.dispose();
  }
}
